//+------------------------------------------------------------------+
//|                                             Future Volume EA.mq4 |
//|                        Copyright 2016, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2016, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

input string futureP             = "Future Volume";
input string indiName            = "Market\\Future Volume";    // Indicator Name
input int    Volume_index        = 3;
input int    Filter1             = 2;
input int    Filter2             = 5;
input int    Filter3             = 3;
input int    Filter4             = 30;
input bool   Arrow_On            = true;
string alertS     =  "iwuiw";
bool SigAlert=false;
bool MobAlert=false;
bool MailAlert=false;

input string ultimateP           = "Ultimate Signal Parameters";
input int    SignalGap           = 4;
input bool   SoundON             = false;
input bool   EmailON             = false;
input bool   Push_Notifications  = false;

input string   tradeP         = "Trade Parameters";
input bool     AutoLot        = true;
input double   LotPercent     = 2;
input int      MaxTrades      = 2;
input double   LotSize        = 0.01;
input double   Lot_Factor     = 1.5;
input double   TakeProfit     = 600;
input double   StopLoss       = 400;
input bool     OppSignal      = false; // Opposite Signal Close
input bool     UseTrailing    = true;
input double   TrailStop      = 200;
input double   TrailStep      = 100;
input double   CloseProfit    = 10;
input double   CloseLoss      = 10;

input int      MagicNumber    = 45242;

int trade;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   createText("Volume BUY: ",20,20,clrBlue);
   createText("Volume SELL: ",20,40,clrBlue);
   createText("Profit: ",20,60,clrBlue);
   createText("Spread: ",20,80,clrBlue);
   
   
   
   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   ObjectsDeleteAll(0,-1,OBJ_LABEL);
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
   ObjectSetString(0,Symbol()+"Volume BUY: ",OBJPROP_TEXT,"Volume BUY: "+"["+(string)allTrades(0)+"]");
   ObjectSetString(0,Symbol()+"Volume SELL: ",OBJPROP_TEXT,"Volume SELL: "+"["+(string)allTrades(1)+"]");
   
   
   string spread=(string)SymbolInfoInteger(Symbol(),SYMBOL_SPREAD);
   ObjectSetString(0,Symbol()+"Spread: ",OBJPROP_TEXT,"Spread: "+spread);
   
   ObjectSetString(0,Symbol()+"Profit: ",OBJPROP_TEXT,"DrawDown: $"+(string)allProfit());
   
   if(IsNewCandle())trade=1;
   
   FindSignal();
   if(UseTrailing && OpenOrdersThisPair(Symbol())==1)Trailing();
   
   if(CloseProfit>0 && allProfit()>=CloseProfit){CLOSEALL(0);CLOSEALL(1);}
   if(CloseLoss>0 && MathAbs(allProfit())>=CloseLoss && allProfit()<0){CLOSEALL(0);CLOSEALL(1);}
  }
//+------------------------------------------------------------------+
void FindSignal(){
   double ultimateB=iCustom(Symbol(),0,"UltimateSignal",SignalGap,SoundON,EmailON,Push_Notifications,1,1);
   double ultimateS=iCustom(Symbol(),0,"UltimateSignal",SignalGap,SoundON,EmailON,Push_Notifications,0,1);
   double indiB=iCustom(Symbol(),0,indiName,0,1);
   double indiS=iCustom(Symbol(),0,indiName,1,1);
   
   if(indiB>0 && indiB!=EMPTY_VALUE && ultimateB>0 && ultimateB!=EMPTY_VALUE){
      OrderEntry(0); 
   }
   
   if((indiB>0 && indiB!=EMPTY_VALUE)){
      if(OppSignal && allProfit()>0)CLOSEALL(1);
      }   
   if((indiS>0 && indiS!=EMPTY_VALUE)){
      if(OppSignal && allProfit()>0)CLOSEALL(0);
      } 
         
   if(indiS>0 && indiS!=EMPTY_VALUE && ultimateS>0 && ultimateS!=EMPTY_VALUE){
      OrderEntry(1);
   }
}

double bsl, btp, ssl ,stp;
double lastLot, slastLot;
void OrderEntry(int direction)
{

   
   double tp = 0,sl = 0;
   int buyticket=0,sellticket=0;   
   double flot=LotSize;
   if(OpenOrdersThisPair(Symbol())==0)slastLot=0;
   
   if(AutoLot)flot=checklotsize(LotPercent);
   
   
     
   if(trade==1){
   
   if(direction==0 && (OpenOrdersThisPair(Symbol())==0||(OpenOrdersThisPair(Symbol())<MaxTrades && lastSignal()==OP_BUY)))
   {
   
   if(lastLot()>0){
      lastLot=slastLot*Lot_Factor;
      slastLot=lastLot;
      Print(lastLot);
      flot=NormalizeDouble(lastLot,2);
      }
   
   if(StopLoss>0){bsl=Ask-(StopLoss*Point);}else{bsl=0;}
   if(TakeProfit>0){btp=Ask+(TakeProfit*Point);}else{btp=0;}
   
      buyticket = OrderSend(Symbol(),OP_BUY,flot,Ask,10,bsl,btp,"EA",MagicNumber,0,Green);
      if(slastLot==0)slastLot=flot;
      trade=0;
      
   }
   
   if(direction==1 && (OpenOrdersThisPair(Symbol())==0||(OpenOrdersThisPair(Symbol())<MaxTrades && lastSignal()==OP_SELL)))
   {
   
   if(lastLot()>0){
      lastLot=slastLot*Lot_Factor;
      slastLot=lastLot;
      Print(lastLot);
      flot=NormalizeDouble(lastLot,2);
      }
      
   if(StopLoss>0){ssl=Bid+(StopLoss*Point);}else{ssl=0;}
   if(TakeProfit>0){stp=Bid-(TakeProfit*Point);}else{stp=0;}
   
      sellticket = OrderSend(Symbol(),OP_SELL,flot,Bid,10,ssl,stp,"EA",MagicNumber,0,Red);
      trade=0;
      if(slastLot==0)slastLot=flot;
      }
      
      }
      
 }
 
 //+------------------------------------------------------------------+
//insuring its a new candle function
//+------------------------------------------------------------------+
bool IsNewCandle()
{
   static int BarsOnChart=0;
	if (Bars == BarsOnChart)
	return (false);
	BarsOnChart = Bars;
	return(true);
}


void CLOSEALL(int type)
{  for(int x=OrdersTotal()-1;x>=0;x--)
  {if(!OrderSelect(x,SELECT_BY_POS,MODE_TRADES))continue;
   if(OrderSymbol()!=Symbol())continue;
   if(OrderMagicNumber()!=MagicNumber)continue;
   if(OrderType()>1)if(OrderDelete(OrderTicket(),clrNONE))continue;
   if(OrderType()==0&&type==0)if(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),10,clrNONE))continue;
   if(OrderType()==1&&type==1)if(OrderClose(OrderTicket(),OrderLots(),OrderClosePrice(),10,clrNONE))continue; 
  }

}

//+-------------------------------
//+ Check Open Orders
//+-------------------------------

int OpenOrdersThisPair(string pair)
{
  int ftotal=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES))
         if(OrderSymbol()==pair && OrderMagicNumber()==MagicNumber) ftotal++;
	  }
	  return (ftotal);
}


void Trailing(){
   //if(OpenTradesThisPair(Symbol())==1){
      double new_sl;
    for(int i = (OrdersTotal()-1); i >= 0; i --)
    {
     if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES)){
         
      if(OrderType()==OP_BUY && Bid-OrderOpenPrice() >= TrailStop*Point && OrderSymbol()==Symbol() && OrderStopLoss()< Bid - TrailStep*Point )
            
            {
                    new_sl = Bid - TrailStep*Point;
                    
                    int mod = OrderModify(OrderTicket(),OrderOpenPrice(),new_sl,OrderTakeProfit(),0,Blue);
                    
            }
      
      
      if(OrderType()==OP_SELL && OrderOpenPrice()-Ask > TrailStop*Point && OrderSymbol()==Symbol() && (OrderStopLoss()> Ask + TrailStep*Point||OrderStopLoss()==0))
      
      {
                     new_sl = Ask + TrailStep*Point;
                     
                    int mod=OrderModify(OrderTicket(),OrderOpenPrice(),new_sl,OrderTakeProfit(),0,Blue);
                    
            }
            
         }
   
   }



}

double checklotsize(double percent){
double lots=0;
   double MinLot = MarketInfo(Symbol(),MODE_MINLOT);
   double MaxLot = MarketInfo(Symbol(),MODE_MAXLOT);
   double Prots = (percent/10000);
  
    lots = NormalizeDouble(AccountBalance()*Prots/100, 2);
    if (lots < MinLot) lots = MinLot;
    if (lots > MaxLot) lots = MaxLot;
    
    return (lots);
  

}

double allProfit(){
   double ftotal=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
      int ordMag=OrderMagicNumber();
         if(OrderSymbol()==Symbol() && ordMag==MagicNumber){
            //if(BasketClose==Fixed_TP){
            ftotal+=OrderProfit();   
            
            }
         }
     }
ftotal=NormalizeDouble(ftotal,Digits);
return(ftotal);
}

int lastSignal()
{
  int fStotal=0;
  datetime lastTime=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()== Symbol() && OrderOpenTime()>lastTime){
            fStotal=OrderType();
            lastTime=OrderOpenTime();
            }
	      }
	  }
	  return (fStotal);
}

double lastLot()
{
  double ftotal=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()== Symbol() && OrderLots()>ftotal){
            ftotal=OrderLots();
            }
	      }
	  }
	  return (ftotal);
}

double allTrades(int type)
{
  double ftotal=0;
   for(int i=OrdersTotal()-1; i >= 0; i--)
	  {
      if(OrderSelect(i,SELECT_BY_POS,MODE_TRADES)){
         if(OrderSymbol()== Symbol() && OrderType()==type && OrderLots()>ftotal){
            ftotal+=OrderLots();
            }
	      }
	  }
	  return (ftotal);
}


void createText(string t, int xx, int yy, color txtColor)
{ 
   string nm=Symbol()+string(t);
   if(ObjectFind(0,nm)<0){
   ObjectCreate(0,nm,OBJ_LABEL,0,0,0);
   ObjectSet(nm,OBJPROP_CORNER,0); 
   ObjectSet(nm,OBJPROP_XDISTANCE,xx);
   ObjectSet(nm,OBJPROP_YDISTANCE,yy); 
   ObjectSet(nm,OBJPROP_SELECTABLE,0); 
   ObjectSet(nm,OBJPROP_HIDDEN,1); 
   //ObjectSetInteger(0,nm,OBJPROP_COLOR,clrDarkRed);
   
   ObjectSetInteger(0,nm,OBJPROP_ANCHOR,ANCHOR_LEFT_UPPER);
   ObjectSetInteger(0,nm,OBJPROP_CORNER,CORNER_LEFT_UPPER);
}
ObjectSetText(nm,t,9,"Arial Bold",txtColor);

}